      subroutine ccbfor_wd

      implicit none

      include "Bounds.p"
      include "Current.h"
      include "Ccbwd.h"
      include "Phantom.h"
      include "System.h"
      include "Constants.p"
      include "Geometry.h"
      include "Geometry.p"
c
      integer ii, jccb,i,k,iatom
      real*8  t1, t2, theta1
c
c
       idir1 = 3 
c
       do ii = 1,maxnph
         nphatom = phat(ii)
c
30       continue
c
         if (idir1.eq.nphatom) goto 40
c
         idir1 = idir1 + 1
c
c     Choose bond angle
c
        call theselect1(1,angle)
c
        theta1 = bondang(idir1-2)
        bondang(idir1-1) = angle(1)
c
        costh= dcos(angle(1))
        sinth= dsin(angle(1))
        costhe1 = dcos(theta1)
        sinthe1 = dsin(theta1)
c
c        etheta = (0.5*kbend*(angle(1)-bonda)
c     :             *(angle(1)-bonda))
c
c*********************************************************************
c****   Choose six potential new configurations for each atom       **
c*********************************************************************
c
        call phisel_wd
c
        do i=1,kccbn
c
          jccb=i
c
c*********************************************************************
c****   Regrow each segment in the six new configurations.          **
c********************************************************************* 
c 
          call ccbbuild_wd(jccb)
c
          call enbccb_wd(jccb,enernew,enermd)
c
          eacc(jccb)=dexp(-beta*enernew(jccb))
	  wsumnew(idir1)=wsumnew(idir1)+eacc(jccb)
c
          eaccmd(jccb) = dexp(-beta*enermd(jccb))
          wsumnewmd(idir1)=wsumnewmd(idir1)+eaccmd(jccb)
          
c
        enddo
c
        if (wsumnew(idir1).eq.0.d0) then
           fail3 = .true.
           return
        endif 
c
        if (wsumnewmd(idir1).eq.0.d0) then
            fail3 = .true.
           return
        endif
c
        if (idir1.ge.phat(1)) then
          do jccb=1,kccbn
            probaccmd(jccb)=eaccmd(jccb)/wsumnewmd(idir1)
          enddo
c
        endif
c
        do jccb=1,kccbn
          probacc(jccb)=eacc(jccb)/wsumnew(idir1)
        enddo
c
c**********************************************************************
c****   Check which one of the six new configurations for each atom  **
c****   according to their weights.                                  **
c**********************************************************************
c
        call ccbcheck_wd
c
       goto 30
c
40     continue
c
       t1 = -(beta * enerccb)
       t2 =  exp(t1) / weight
       mid(ii) = mid(ii) + t2
c
       enerccb = enerccb - enerccben + enerccbmd
       weight = (weight/weighten) * weightmd  
c
       enddo
c
      fail3 = .false.
c
       return
      end
