      subroutine enbccb_wd(jccb,energy,energymd) 
c
      implicit none
c 
      include "Bounds.p"
      include "Constants.p"
      include "System.h"
      include "Current.h"
      include "Geometry.p"
      include "Seed.h"
      include "Lennard_Jones.p"
      include "Lennard_Jones.h"
      include "Ccbwd.h"
      include "Phantom.h"
      include "Vtorsion.h"
c
      integer  k, jccb,jat,i,l,ll, iph
c
      real*8   xij(3),rij2,rmin2,energy(kccbn)
      real*8   energymd(kccbn)
      real*8   sds,xi,vk,vk1,vk2,t1,t2,einc
      real*8   enphi, cosphip, cosphip2, cosphip3
c     _________________________________________________________
c
      energy(jccb)   = 0.d0
      energymd(jccb) = 0.d0
      rmin2          = 0.d0

c   calculate energy of the grown phantom chain
c
      if (idir1.gt.4) then
c
        do iph = idir1-4,1,-1
c
           xij(1) = xnewc(jccb,1) - xt(iph,1)
           xij(2) = xnewc(jccb,2) - xt(iph,2)
           xij(3) = xnewc(jccb,3) - xt(iph,3)
c
           rij2   = xij(1)*xij(1) + xij(2)*xij(2)
     :              + xij(3)*xij(3)
c
           
	       l  = idph(iph)
             ll = idph(idir1)

		 if(rij2.lt.r2nb(l+ll+1)) then
c
c    use forward difference computation of the L-J spline
c
             
             sds = (rij2 - rmin2)/ interval(l+ll+1)
             k   = sds
             xi  = sds - 1.d0*k
             vk  = elj(k,l+ll+1)
             vk1 = elj(k+1,l+ll+1)
             vk2 = elj(k+2,l+ll+1)
             t1  = vk  + (vk1 - vk)  * xi
             t2  = vk1 + (vk2 - vk1) * (xi - 1.d0)
             einc = t1 + (t2 - t1) * xi * 0.5d0
c
             energy(jccb) = energy(jccb) + einc
c
c
             if(idph(idir1).eq.1) then
c
                vk  = elj(k,l+1)
                vk1 = elj(k+1,l+1)
                vk2 = elj(k+2,l+1)
                t1  = vk  + (vk1 - vk)  * xi
                t2  = vk1 + (vk2 - vk1) * (xi - 1.d0)
                einc = t1 + (t2 - t1) * xi * 0.5d0
                energymd(jccb) = energymd(jccb) + einc
              endif
c
            endif          
c
           enddo
c
         endif
c
c    calculate torsional potential 
c
        cosphip = dcos(phiccb(jccb))
        cosphip2 = dcos(2*phiccb(jccb))
        cosphip3 = dcos(3*phiccb(jccb))

        enphi   = AlphaRB(1) * (1 + cosphip)
     :          + AlphaRB(2) * (1 - cosphip2)
     :          + AlphaRB(3) * (1 + cosphip3)

c	enphi = AlphaRB(0) + AlphaRB(1)*(1-cosphip) +
c     &            AlphaRB(2)*(1-cosphip3) +
c     &            AlphaRB(3)*(1-cosphip)**5 +
c     &            AlphaRB(4)*exp(-30.0d0*phiccb(jccb)*phiccb(jccb))

c
        energy(jccb) = energy(jccb) + enphi
c
        energymd(jccb) = energymd(jccb) + enphi
c 
      return
      end
