       program polybead
c
c     
c     A code for the simulation of phantom unperturbed chains.
c
c
c     P. V. Krishna Pant, Chemical Engineering, UC, Berkeley
c
c     ____________________________________________________________
c
      implicit none
cc
      include "Bounds.p"
      include "Current.h"
      include "System.h"
      include "Phantom.h"
      include "Increm.h"
      include "Lennard_Jones.h"
      include "Seed.h"
      
      integer  iatom, iter1
c     ____________________________________________________________
c
c
      call startup 
c
      if (icrash.eq.1) then
         iter1=iternew+1
      else
         iter1=1
      endif
c
c
      write(*,'("Starting configuration=",I10)')iter1
      do 1000 iter = iter1, maxits
c
         call ccbwidom 
c
         call perioddump            ! Computations on "current"
                                    ! configuration 
c
         if (mod(iter,maxits/2).eq.0) then
c
          open (unit=17,file='crash',status='unknown',
     :          form='unformatted')
          write(17) iter
          write(17) countwd
          write(17) mid
          write(17) iseed, temperature, 
     :             eps, maxnph, phat
          write(17) nsucc1,nmove1,nsucc2,nmove2
          write(17) nsucc5,nmove5,nsucc6,nmove6,nsucc7,nmove7
c
          close(unit=17)
      endif

1000  continue
c
      stop
      end
