      subroutine ccbbuild_wd(jccb)
c
      implicit none
c
      include "Bounds.p"
      include "Constants.p"
      include "System.h"
      include "Current.h"
      include "Geometry.p"
      include "Geometry.h"
      include "Ccbwd.h"
      include "Seed.h"
      include "Phantom.h"
c
      integer      k,jccb, i1, i2, i3
c
      real*8       r12, r32, diff23(3), diff34(3), diff(2,3)
      real*8       r21p(3), cross(3), crossmag, ratio
      real*8       diffn(3), random
c     _____________________________________________________________
c
c     construct the new cut-off atom 
c
      i1 = idir1 - 3
      i2 = idir1 - 2
      i3 = idir1 - 1
c
c     _______________________________________________________
c
      do k = 1, 3
         diff(1,k) = xt(i3,k) - xt(i2,k)
         diff(2,k) = xt(i1,k) - xt(i2,k)
      end do
c
      r12 = dsqrt (diff(2,1)**2 + diff(2,2)**2 + diff(2,3)**2)
      r32 = dsqrt (diff(1,1)**2 + diff(1,2)**2 + diff(1,3)**2)
c
      do k = 1, 3
         diff23(k) =  diff(1,k)  * costhe1 * (r12 / r32)
         diff34(k) =  diff(1,k)  * costh * (bondl / r32)  
         r21p(k)   =  diff(2,k) + diff23(k)
      end do
c
c     compute cross product of r21p and diff23
c
      cross(1) = r21p(2)*diff23(3) - r21p(3)*diff23(2)
      cross(2) = r21p(3)*diff23(1) - r21p(1)*diff23(3)
      cross(3) = r21p(1)*diff23(2) - r21p(2)*diff23(1)
c
      crossmag = dsqrt(cross(1)*cross(1) + cross(2)*cross(2) 
     :                 + cross(3)*cross(3))
c
      ratio = sinth/sinthe1 
c
      do k = 1, 3
         diffn(k)=diff34(k)+dcos(phiccb(jccb))*r21p(k)*ratio
     :        +dsin(phiccb(jccb))*(cross(k)/crossmag)*bondl*sinth
         xnewc(jccb,k) = xt(i3,k) + diffn(k)
      end do
c     _____________________________________________________________
c
     
      return
      end
