       subroutine ccbinit 
c
       implicit none
c
       include   "Bounds.p"
       include   "Current.h"
       include   "System.h"
       include   "Seed.h"
       include   "Constants.p"
       include   "Geometry.h"
       include   "Geometry.p"
       include   "Phantom.h"
       include   "Ccbwd.h"
c
       integer    k
c
       real*8     xp(3),yp(3),zp(3),
     :            theta, phi1, tanth, random, alfa,
     :            alfa1, dx, dy, dz,zetap
       real*8     diff(2,3), r12,r32,the,costhe2
c
c   put the first atom at the origin 
c
       xt(1,1) = 0.d0
       xt(1,2) = 0.d0
       xt(1,3) = 0.d0
c
c   put the second atom using spherical coordinates
c
       theta = acos(2.*random(iseed)-1.)
       phi1 = random(iseed) * TwoPi
c
       xt(2,1) = xt(1,1) + bondl*dsin(theta)*dcos(phi1)
       xt(2,2) = xt(1,2) + bondl*dsin(theta)*dsin(phi1)
       xt(2,3) = xt(1,3) + bondl* dcos(theta)
c
c   place the third atom
c
       dx = xt(2,1) - xt(1,1)
       dy = xt(2,2) - xt(1,2)
       dz = xt(2,3) - xt(1,3)
c
       xp(1) = dx / bondl
       xp(2) = dy / bondl
       xp(3) = dz / bondl
c
        phi1 = random(iseed) * TwoPi 
        tanth = -xp(3) / (xp(1)*dcos(phi1) + xp(2)*dsin(phi1))
        theta = atan(tanth)
c
        zp(1) = dcos(phi1) * dsin(theta)
        zp(2) = dsin(phi1) * dsin(theta)
        zp(3) = dcos(theta)
c
        yp(1) = -(xp(2)*zp(3) - xp(3)*zp(2))
        yp(2) =  (xp(1)*zp(3) - xp(3)*zp(1))
        yp(3) = -(xp(1)*zp(2) - xp(2)*zp(1))
c
        call theselect1(1,angle)
c
        costh = dcos(angle(1))
        sinth = dsin(angle(1))
c
        alfa  = bondl * costh
        alfa1 = bondl * sinth
c
        xt(3,1) = xt(2,1) + alfa*xp(1) + alfa1*yp(1)
        xt(3,2) = xt(2,2) + alfa*xp(2) + alfa1*yp(2) 
        xt(3,3) = xt(2,3) + alfa*xp(3) + alfa1*yp(3) 

c      do k = 1, 3
c         diff(1,k) = xt(3,k) - xt(2,k)
c         diff(2,k) = xt(1,k) - xt(2,k)
c      end do
c
c      r12 = dsqrt (diff(2,1)**2 + diff(2,2)**2 + diff(2,3)**2)
c      r32 = dsqrt (diff(1,1)**2 + diff(1,2)**2 + diff(1,3)**2)
c
c      costhe2 = -(diff(1,1)*diff(2,1) + diff(1,2)*diff(2,2)
c     :          + diff(1,3)*diff(2,3)) / (r12 * r32)
c       the=acos(costhe2)
c       write(*,*)"the",the,the*180.d0/3.141592654
c
c
c    calculate theta energy
c
c        enerccb = 0.5*kbend*(angle(1)-bonda)*(angle(1)-bonda)
c
        bondang(2) = angle(1)
c
       return 
       end
