      subroutine inputs 
c
      implicit none
c
      include "Bounds.p"
      include "System.h"
      include "Seed.h"
      include "Current.h"
      include "Lennard_Jones.h"
      include "Intend.h"
      include "Phantom.h"
      include "Temp.h"
c
      integer  ich, i, j, iatom, k, l, m, iat
c
c     _______________________________________________________
c
         open (unit=18,file='CUCin')
      read(18,*)
      read(18,*) icrash
c
c    starting run from a crash file
c
       if (icrash.eq.1) then
c
         open (unit=17,file='crash',status='old',
     :       form='unformatted')
         read(17) iternew
         read(17) countwd
         read(17) mid
         read(17) iseed, temperature,
     :            eps, maxnph, phat
         read(17) nsucc1,nmove1,nsucc2,nmove2
         read(17) nsucc5,nmove5,nsucc6,nmove6,nsucc7,nmove7
c
         close(unit=17)
c
         read(19,*)
         read(19,*) maxits
c
         beta = 1.d0 / (1.987d-3 * temperature)
         write(*,'(''beta = '',f10.6,2x,"Temp= ",f10.2)') beta,
     :             temperature
c
c
       else
c
c

      read(18,*)
      read(18,*) maxits
c
      read(18,*)
      read(18,*) dumpfreq
c
c     read in the random number seed
c
      read(18,*)
      read(18,*) iseed

      read(18,*)
      read(18,*) temperature  ! in K

      read(18,*)
      read(18,*)(sigreal(i),i=1,3) 

      read(18,*)
      read(18,*)(eps(i),i=1,3) 
c 
      beta = 1.d0 / (1.987d-3 * temperature)
      write(*,*) 'beta = ', beta
c
c
      read(18,*)
      read(18,*) maxnph
c
      read(18,*)
      read(18,*) (phat(i),i=1,maxnph)
	close(18)
c
c   Initialize counter and other variables involved in widom insertions.
c
      countwd  = 0
      do i = 1,maxnph
         mid(i)      = 0.d0
      enddo
c
c
      endif
c ***********************************************************
c
c       write(*,'("length of inserted chain molecule:",2x,I2)')
c     :           nphatom
c
      return
      end
