
      subroutine perioddump

c
      implicit none
c
      include     "Seed.h"
      include     "Bounds.p"
      include     "System.h"
      include     "Current.h"
      include     "Phantom.h"
      include     "Temp.h"
      include     "Increm.h"
c
      real*8       midav, t1(maxins)
c
      integer      i,  ichain
      integer      j, dump2, ii, temp
c     _____________________________________________________________
c
c
c    write out running average of the squared end to end distance
c
      dump2 = 0.25 * dumpfreq
      if (mod(iter,dump2).eq.0) then
c
      do ii = 1,maxnph
        midav = mid(ii) / countwd
        t1(ii) = dlog(midav) / beta
c
      enddo
c
      write(102,'(I10,1x,14(f10.6,1x))') iter,
     :                     (t1(ii), ii=1,maxnph)
      write(*,'(I10,1x,14(f10.6,1x))') iter,
     :                     (t1(ii), ii=1,maxnph)
c
      endif
c

       return
c
      end
